/*************************************************************************************************************
		BPLcc_Main.c Created By Vasileios Kon. Pothos (GR)05. (terablade2001@yahoo.gr) - More At End Of This File
**************************************************************************************************************/
#include "BPlcc_glv2.3.h"
#pragma lib <BPLcc_GLv2.3.lib>
extern BPLcc_WinData BPLcc_InitWinData_Obj;

/* Most Changefull varialbes that programmers can change fast for their OpenGL application are defined here.
	 At the - BPLcc_OpenGL_Window_Parameters_Set() - function (End Of This File) you are going to Find more Variables
	 that you might want to change if you are Experienced with Windows Processes. */
#define BPLCC_WINDOW_TITLE "BPLcc OpenGL Application"
#define BPLCC_SCREEN_X 640
#define BPLCC_SCREEN_Y 480
#define BPLCC_RESIZEWINDOW true
#define BPLCC_SHOWMOUSECURSOR true
#define BPLCC_EXIT_ON_ESCAPE true


/* Initialization after GL Has Loaded.********************************** */
void ToDo_Init_OpenGL(void) {
}

/* Render Scene Function.************************************************ */
void ToDo_RenderScene(void) {
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	glBegin(GL_TRIANGLES);
		glColor3f(1,0,0); glVertex3f(-1,1,-5);
		glColor3f(0,1,0); glVertex3f(0,0,-5);
		glColor3f(0,0,1); glVertex3f(1,1,-5);
	glEnd();
	//Until UpHere Render Code.
	SwapBuffers(BPLcc_InitWinData_Obj.hDC);
}

/* Main Loop Function - Use for continuous tracking. ********************* */
void ToDo_MainLoop(void) {
}


//*****************************************************************************************************
/* Use to add KEYS/MOUSE actions. **************************************** */
void ToDo_WinProcMessage(UINT uMsg, WPARAM wParam, LPARAM lParam) {
}

/* Before Window created, possible code. (F.E. ask Fullscreen or Not).**** */
void ToDo_WinMain(void) {
	if(MessageBox(NULL, "Use FULL Screen?", "Screen Mode", MB_YESNO | MB_ICONQUESTION) == IDNO)
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_FULLSCREEN, false);
}

/* Last Function Called before termination for Destroying/Free "Objects"/Memory */
void ToDo_AtExitProgram(void){
}

/* ****************************************************************************************** */
/* OpenGL Window Application Parameters --- Modify This Function Only Experience Programmers! */
/* ****************************************************************************************** */
void BPLcc_OpenGL_Window_Parameters_Set(void) {
	int BPLcc_InitWindow_FrustumData[6] = {-1.0, 1.0, -1.0, 1.0, 1.0, 50.0}; /* glFrustum() Data On Initialization. */
	BPLcc_WinData_SetPc(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_NAME, BPLCC_WINDOW_TITLE);
	BPLcc_WinData_SetPc(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_CLASSNAME, "Class BPLcc OpenGL");
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_STYLE, (CS_HREDRAW | CS_VREDRAW));
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_BACKBRUSH, (COLOR_WINDOW+1));
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_FULLSCR_APPSTYLE, (WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN));
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_WINDOWSCR_APPSTYLE, (WS_OVERLAPPEDWINDOW | WS_CLIPSIBLINGS | WS_CLIPCHILDREN));
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_PIXF_FLAGS, (PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER));
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_PIXF_LAYERMASK, PFD_MAIN_PLANE);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_PIXF_PIXELTYPE, PFD_TYPE_RGBA);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_PIXF_ACCUMBITS, 0);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_PIXF_STENCILBITS, 0);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_WIDTH, BPLCC_SCREEN_X);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_HEIGHT, BPLCC_SCREEN_Y);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_DEPTH, 32);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_RESIZEDWINDOW, BPLCC_RESIZEWINDOW);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_EXITONESCAPE, BPLCC_EXIT_ON_ESCAPE);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_SHOWCURSOR, BPLCC_SHOWMOUSECURSOR);
	BPLcc_WinData_SetPi(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_GL_FRUSTUMDATA, BPLcc_InitWindow_FrustumData, 6);

/* The Below Function Set's Window Screen (Not Full Screen). But Because we use it at ToDo_WinMain() function
	 so that user on runtime will decide if he want's full screen or not, we have comment it here...
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_FULLSCREEN, false); /* Default is: Full Screen Mode
*/

/* The Below Statements Initilalize Window with the Resource ICON/CURSOR. If they are not used(Like now) the Library
	 uses the Default ICON (IDI_APPLICATION) and the Default Cursor (IDC_ARROW) defined in Win32... To Start with your
	 ICON / CURSOR change IDIICON100 / IDCURSOR200 names to your corresponding resources at the below statements.
	BPLcc_WinData_SetID(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_ICON, (LPCSTR) IDIICON100, false);
	BPLcc_WinData_SetID(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_CURSOR, (LPCSTR) IDCURSOR200, false);
*/

	/* Use this Statement's to Set Your Window OpenGL Application Position to Screen. CW_USEDEFAULT uses windows default(moving)*/
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_WINPOSX, CW_USEDEFAULT);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_WINPOSY, 0);
}
/* END */


/*-----------------------------------------------------------------------------------------------------------
*************************************************************************************************************
		This is a Skeleton Program in C that shows how BPLcc_GLv2.3.lib can be used from begginers.
		In Order To Interface with BPLcc_GLv2.3.lib you need the following functions:

		void ToDo_Init_OpenGL(void)				:
																				Function Called After the OpenGL has been Initialized - User
																				can initialize (relative to) OpenGL data here.
		void ToDo_RenderScene(void)				:
																				Function Called Concecutively for Rendering the OpenGL 3D Scene
																				to Screen.
		void ToDo_MainLoop(void)					:
																				Function that's called just before ToDo_RenderScene() function -
																				User can check data here & update variables (timers e.t.c).
		void ToDo_WinProcMessage(UINT uMsg, WPARAM wParam, LPARAM lParam) :
																				This function give the capability to user to handle the messeges
																				from the system (such as keyboard/mouse input, windows close e.t.c.)
																				The Very Basic messages works are checked by the lib, and only if
																				the user want it (f.e. ResizeWindow, ExitOnEscape (Look #defines at
																				start)).
		void ToDo_WinMain(void)						:
																				This is the Starter Function of the Lib. Do here everything you
																				want to do, at the program's start. This function is the first
																				thing to be executed after WinMain().

		void BPLcc_OpenGL_Window_Parameters_Set(void) :
																				For Experience Programmers Only. This function gives more accessabi
																				lity on how the window is create. Let this function be at a part of
																				your code, that will not trouble you (F.E. at the end of your prog).

		void ToDo_AtExitProgram(void)			:
																			 When you have "Objects", or data that must be destroyed freeing the
																			 memory you can add code to this function. It's the Function Called
																			 At the termination of your application. For Example, here you should
																			 use BPLcc_FONTS_Destroy(&(<PointerToFont>)) in order to destroy Font
																			 Objects that this Lib Supports.

		The BPLcc_GL.lib was created for easy making OpenGL applications for the IDE lcc-win32.
		It was based on OOP, as much it could done this in C. "Objects" in this library are structs, with specified
		by name function's which take a pointer to the corresponded Object, in order to change it's data.
		Copyright @ Vasileios Kon. Pothos (GR).
		- Finally this Lib was created with Structure Aligment "Default". With other Structures Aligments you'll get
		wrong data from the lib's code (Yes.. I lost ~3 hours to see that "problem"...! - I got crazy why the
		variables didn't copy write to programs.)

		BPLcc_GL Library v2.3 Supports:
				- Initialize OpenGL Window in Full OR Windowed Style.
				- Keyboard and Mouse Objects support.
				- Camera Object support.
				- Stadar Window True Fonts Object Support.
				- 3D Window True Fonts Object Support.
				- TGA Image Files Loading.
				- Texture Handling Object.
				- Fog Handling Object.

		You may use this file to "Build On It" your's OpenGL Applications.
		You can see the functions supported for each object at the corresponding .h file that comes with this lib.

		> If anyone is interested to develop more this library (adding for example: Texture Objects, Lighting
		Objects, Shadow Objects, Special Effects Objects (F.E. Lightings, e.t.c.), Image Reading (.bmp, .jpg, e.t.c.)
		and Loading Objects, 3D-Shapes handling Objects (.mds, .ase, e.t.c. -from GMax f.e.), Animation & Video
		handling Objects, e.t.c e.t.c e.t.c.) can inform me at terablade2001@yahoo.gr. This request is only for
		serius programmers that like lcc-win32 programming, this style of OpenGL handling I use, and this way of
		handling object in C. Note wrote at: 17/11/05. ~ Vasileios Kon. Pothos.
*************************************************************************************************************/
