/* Simple (v2.3):
	- Use Mouse & A/W/S/D & Arrow Keys to Move The Camera.
	- Use Left/Right Click To Rotate Triangle.
	- Use Left/Right Double Click To Rotate by 90 the Triangle.
		(Double Click Works only if the window has CS_DBLCLKS Style attritube.
		Delete this attritube at the BPLcc_OpenGL_Window_Parameters_Set() function to see the difference. }
	- Check keys F1 - F6, and 1-5. (5 For Skinning)
*/

#include "BPlcc_glv2.3.h"
#pragma lib <BPLcc_GLv2.3.lib>
extern BPLcc_WinData BPLcc_InitWinData_Obj;

#define BPLCC_WINDOW_TITLE "BPLcc Library v2.3 - Simple Example..."
#define BPLCC_SCREEN_X 640
#define BPLCC_SCREEN_Y 480
#define BPLCC_RESIZEWINDOW true
#define BPLCC_SHOWMOUSECURSOR false
#define BPLCC_EXIT_ON_ESCAPE true

bool Fog_Status=false; // Starting With FOG Disabled.
bool SkinWindow=false; // Demostration! :P (Anyone can do it! - Easily!) Thanks to Vander Nunes for Skinning Tutorials! :)

BPLcc_Keys K; // Keys Object.
BPLcc_Mouse M; // Mouse Object.
BPLcc_Camera C; // Camera Object.
BPLcc_Font F,F2,F3; // Fonts 1,2,3
BPLcc_Font3D F3D, F3D2; // 3D Fonts 1,2
BPLcc_Texture2D Tex; // 2D Texture Object. - You Should Not Have More Than One Texture Object.
BPLcc_Fog Fog; // Fog Object.



float x=180;
float z=-10;
float i;
void ToDo_Init_OpenGL(void) {
	SetCursorPos(BPLCC_SCREEN_X >> 1,BPLCC_SCREEN_Y >> 1); // At Start Set Mouse To Center OpenGL application. (-So The Camera Won't Move).


	glEnable(GL_DEPTH_TEST);
	BPLcc_TXRE_Create(&Tex, 1); // Create One 2D Texture.
	BPLcc_TXRE_TGALoadSet(&Tex,1,".\\Data\\All_Is_Luck.tga"); // Load 2D Texture No. 1 with Image: All_Is_Luck.tga

	BPLcc_Keys_Create(&K); // Initialize Keys Object.
	BPLcc_Mus_Create(&M);  // Initialize Mouse Object.

	BPLcc_CAM_Create(&C,BPLCC_SCREEN_X,BPLCC_SCREEN_Y); // Initialize Camera Object.
	BPLcc_CAM_Place(&C,0,0,10,0,00,-1,0,1,0); // Initialize Camera Starting Position.

	BPLcc_FONTS_Create(&F); // Initialize Font 1.

	BPLcc_FONTS_Create(&F2); // Initialize Font 2.
	BPLcc_FONTS_SetFontsType(&F2, "Times New Roman", 20, 200, true, false, 500, 100, 0); // Set Font 2 Type.
	BPLcc_FONTS_Color(&F2,1.0,0.7,0); // Set Font 2 Color.

	BPLcc_FONTS_Create(&F3); // Initialize Font 3.
	BPLcc_FONTS_SetFontsType(&F3, "Courier New", 20, 200, true, false, 500, 200, 0); // Set Font 3 Type.
	BPLcc_FONTS_Color(&F3,0.6,1,0); // Set Font 3 Color.

	BPLcc_FONT3D_Create(&F3D); // Initialize 3DFont 1.
	BPLcc_FONT3D_SetFontType(&F3D,"Arial",75,0.5,false,0,0,true,true,10,10,false); // Set 3DFont 1 Type.
	BPLcc_FONT3D_Color(&F3D, 0.2, 0.5, 1.0); // Set 3DFont 1 Color.

	BPLcc_FONT3D_Create(&F3D2); // Initialize 3DFont2.
	BPLcc_FONT3D_SetFontType(&F3D2,"Times New Roman",50,0.2,true,0,0,true,false,10,10,true); // Set 3DFont 2 Type.
	BPLcc_FONT3D_Color(&F3D2, 0.2, 1.0, 0.5); // Set 3DFont 2 Color.

	BPLcc_FOG_Create(&Fog); // Create Fog Object.
	// Initialize Fog Data (Distance, Mode, Start, End, HINT);
	BPLcc_FOG_SetData(&Fog,0.07,BPLCC_GL_FONT_MODE_EXP2,0,50,BPLCC_GL_FONT_HINT_NICEST);
	BPLcc_FOG_Enable(&Fog); // Enable Fog with data. (Now can use glEnable(GL_FOG) / glDisable(GL_FOG))
	glDisable(GL_FOG);
}

void ToDo_RenderScene(void) {
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();

	BPLcc_CAM_Look(&C); // Set Window View, to What The Camera is viewing.

	BPLcc_FONT3D_SetSize(&F3D,x/10+50); // On Rendering Setting Size of 3DFont1.
	BPLcc_FONT3D_Text(&F3D,0,0,-3,"Intelligence!"); // Write Something with 3DFont1.
	BPLcc_FONT3D_TextR(&F3D,0,-2.5,-2.5,-45,1,0,0,"Theta: %.1f",x); // Write Something Else with 3DFont1 Rotated.

	BPLcc_FONT3D_TextR(&F3D2,0,1.5,-3,180-x,0,1,0,"Super"); // Write Something with 3DFont2 Rotated.
	BPLcc_FONT3D_TextR(&F3D2,0,1.8,-3,x,0,1,0,"-------"); // Write Something else with 3DFont2 Rotated.
	BPLcc_FONT3D_TextR(&F3D2,0,1.2,-3,x,0,1,0,"-------"); // Write Something else with 3DFont2 Rotated.

	glColor3f(0,1,0);
	for (i = z; i < z+30; i+=1) {
		glPushMatrix();
		glBegin(GL_LINES);
			glVertex3f(-10,10,i);
			glVertex3f(-10,-10,i);
		glEnd();
		glBegin(GL_LINES);
			glVertex3f(10,10,i);
			glVertex3f(10,-10,i);
		glEnd();
		glBegin(GL_LINES);
			glVertex3f(10*cos(i),10,i);
			glVertex3f(-10*sin(i),10,i);
		glEnd();
		glPopMatrix();
	}
	z+=0.05; if (z>=-19) { z=-20; }

  /* Create Two Triangles..........................*/
	glPushMatrix();
	glRotatef(x,0,0,1);
	glBegin(GL_TRIANGLES);
		glColor3f(1,0,0); glVertex3f(-1,1,-5); glColor3f(0,1,0); glVertex3f(0,0,-5); glColor3f(0,0,1); glVertex3f(1,1,-5);
	glEnd();
	glPopMatrix();
	glPushMatrix();
	glRotatef(-x,0,0,1);
	glBegin(GL_TRIANGLES);
		glColor3f(1,0,0); glVertex3f(-1,1,-2); glColor3f(0,1,0); glVertex3f(0,0,-2); glColor3f(0,0,1); glVertex3f(1,1,-2);
	glEnd();
	glPopMatrix();
	/* Until Here......................................*/

	BPLcc_FONTS_Text(&F2,20,0,"It was a hard time... when I decided to make this OpenGL lib for lcc-win32..."); // Write Something with Font 2.
	BPLcc_FONTS_Text(&F3,20,30,"But I hope, this Lib will help others to learn and make"); // Write Something with Font 3.
 	BPLcc_FONTS_Text(&F,480,50,"something good... :)"); // Write Something With Font 1.
	BPLcc_FONTS_Text(&F,2,430,"http://launch.groups.yahoo.com/group/TALBs_Group/"); // TALBs.. One of my ideas about music! Join Us! VKP-|||||||
	BPLcc_FONTS_Text(&F2,0,BPLCC_SCREEN_Y-F2.height-5,"Camera Pos: X: %f   Y: %f   Z: %f",C.Pos.x,C.Pos.y,C.Pos.z); // Write Camera Pos. with Font 2.
	if (Fog_Status) { BPLcc_FONTS_Text(&F2,10,120,"FOG is <ON>"); } else { BPLcc_FONTS_Text(&F2,10,120,"FOG is >OFF<"); } // Tell About FOG Status.


	/* Creating the Texture Image......................... */
	glEnable(GL_TEXTURE_2D);
	glPushMatrix();
	BPLcc_TXRE_Bind(&Tex,1);
	glTranslatef(0,-5,-6);
	glRotatef(-45,1,0,0);
	glScalef(7,7,7);
	glBegin(GL_QUADS);
			glTexCoord2d(0.0f,0.0f); glVertex3f(-1.0f, -1.5f,0);
			glTexCoord2d(1.0f,0.0f); glVertex3f( 1.0f, -1.5f,0);
			glTexCoord2d(1.0f,1.0f); glVertex3f( 1.0f,  1.5f,0);
			glTexCoord2d(0.0f,1.0f); glVertex3f(-1.0f,  1.5f,0);
	glEnd();
	glPopMatrix();
	glDisable(GL_TEXTURE_2D);
	/* End Of Creating the Texture Image..................... */

	SwapBuffers(BPLcc_InitWinData_Obj.hDC); // Update the View.
}

void ToDo_MainLoop(void) {
	BPLcc_CAM_Update(&C); // Update Cameras Auto Moving/View (By A/S/W/D, Arrows, Mouse).
	// Keyboard Actions.
	if (K.keys[VK_ADD]==true) { K.keys[VK_ADD]=false; x+=2.5f; }
	else if (K.keys[VK_SUBTRACT]==true) { K.keys[VK_SUBTRACT]=false; x-=2.5f; }
  else if (K.keys[VK_F1]==true) { K.keys[VK_F1]=false; BPLcc_CAM_Parameter(&C, BPLCC_CAM_SET_PARAMETER_MOVE, 0); } // Disable Move
	else if (K.keys[VK_F2]==true) { K.keys[VK_F2]=false; BPLcc_CAM_Parameter(&C, BPLCC_CAM_SET_PARAMETER_MOVE, 1); } // Enable Move
  else if (K.keys[VK_F3]==true) { K.keys[VK_F3]=false; BPLcc_CAM_Parameter(&C, BPLCC_CAM_SET_PARAMETER_VIEW, 0); } // Disable Mouse View.
	else if (K.keys[VK_F4]==true) { K.keys[VK_F4]=false; BPLcc_CAM_Parameter(&C, BPLCC_CAM_SET_PARAMETER_VIEW, 1); } // Enable Mouse View.
  else if (K.keys[VK_F5]==true) { K.keys[VK_F5]=false; BPLcc_CAM_Parameter(&C, BPLCC_CAM_SET_PARAMETER_UPDATE, 0); } // Disable Camera Update.
	else if (K.keys[VK_F6]==true) { K.keys[VK_F6]=false; BPLcc_CAM_Parameter(&C, BPLCC_CAM_SET_PARAMETER_UPDATE, 1); } // Enable Camera Update.
	else if (K.keys[VK_1]==true) { K.keys[VK_1]=false; BPLcc_CAM_Parameter(&C, BPLCC_CAM_SET_PARAMETER_VIEWSPEEDX, 250); } // Set Fast View SpeedX
	else if (K.keys[VK_2]==true) { K.keys[VK_2]=false; BPLcc_CAM_Parameter(&C, BPLCC_CAM_SET_PARAMETER_VIEWSPEEDX, 800); } // Set Normal View SpeedX
	else if (K.keys[VK_3]==true) { K.keys[VK_3]=false; BPLcc_CAM_Parameter(&C, BPLCC_CAM_SET_PARAMETER_VIEWSPEEDY, 250); } // Set Fast View SpeedY
	else if (K.keys[VK_4]==true) { K.keys[VK_4]=false; BPLcc_CAM_Parameter(&C, BPLCC_CAM_SET_PARAMETER_VIEWSPEEDY, 800); } // Set Normal View SpeedY
	else if (K.keys[VK_5]==true) { K.keys[VK_5]=false; // Do The Skinning!!!
		if (BPLcc_InitWinData_Obj.FullScreen == false) {
				if (SkinWindow==false) { SkinWindow=true;
				HRGN hRegion1 = CreateEllipticRgn(220,180,420,340);
				SetWindowRgn(BPLcc_InitWinData_Obj.hWnd, hRegion1, TRUE);
				DeleteObject(hRegion1);
			} else {	SetWindowRgn(BPLcc_InitWinData_Obj.hWnd, NULL, TRUE);	SkinWindow=false; }
		}
	}

	// Mouse Actions.
	if (M.keys[MS_LB]==true) { M.keys[MS_LB]=false; x+=0.5; if (!Fog_Status) { glEnable(GL_FOG); } else { glDisable(GL_FOG); } Fog_Status = !Fog_Status;}
	else if (M.keys[MS_RB]==true) { M.keys[MS_RB]=false; x-=0.5;	}
	else if (M.keys[MS_DRB]==true) { M.keys[MS_DRB]=false; x+=90; }
	else if (M.keys[MS_DLB]==true) { M.keys[MS_DLB]=false; x-=90; }
	else if (M.Wheel == MS_WHEEL_UP) { x+=(float)M.Wheel/10; BPLcc_Mus_ClWheel(&M); }
	else if (M.Wheel == MS_WHEEL_DOWN) { x+=(float)M.Wheel/10; BPLcc_Mus_ClWheel(&M); }
	else if (M.keys[MS_MB]==true) { M.keys[MS_MB]=false; x=0; }
	else if (M.keys[MS_DMB]==true) { M.keys[MS_DMB]=false; x=180; }

}


/*-------------------------------------------------------------------------------------------------------*/
void ToDo_WinProcMessage(UINT uMsg, WPARAM wParam, LPARAM lParam) {
	BPLcc_Keys_Update(&K, uMsg, wParam); // Update Keyboard Messages.
	BPLcc_Mus_Update (&M, uMsg, wParam); // Update Mouse Messages.
}

void ToDo_WinMain(void) {
	// Ask User If he wants a Full Screen Or Not. Depending his Answer Set The View.
	if(MessageBox(NULL, "Use FULL Screen?", "Screen Mode", MB_YESNO | MB_ICONQUESTION) == IDNO)
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_FULLSCREEN, false);
}

void ToDo_AtExitProgram(void){
	BPLcc_FONT3D_Destroy(&F3D); // Release the 3DFont 1
	BPLcc_FONT3D_Destroy(&F3D2); // Release the 3DFont 2
	BPLcc_FONTS_Destroy(&F);	// Release the Font 1
	BPLcc_FONTS_Destroy(&F2); // Release the Font 2
	BPLcc_FONTS_Destroy(&F3); // Release the Font 3
	BPLcc_TXRE_Destroy(&Tex); // Destroy The Tex Object.
}



/* ****************************************************************************************** */
/* OpenGL Window Application Parameters --- Modify This Function Only Experience Programmers! */
/* ****************************************************************************************** */
void BPLcc_OpenGL_Window_Parameters_Set(void) {
	int BPLcc_InitWindow_FrustumData[6] = {-1.0, 1.0, -1.0, 1.0, 1, 50.0}; /* glFrustum() Data On Initialization. */
	BPLcc_WinData_SetPc(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_NAME, BPLCC_WINDOW_TITLE);
	BPLcc_WinData_SetPc(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_CLASSNAME, "Class BPLcc OpenGL");
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_STYLE, (CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS));
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_BACKBRUSH, (COLOR_WINDOW+1));
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_FULLSCR_APPSTYLE, (WS_POPUP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN));
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_WINDOWSCR_APPSTYLE, (WS_OVERLAPPEDWINDOW | WS_CLIPSIBLINGS | WS_CLIPCHILDREN));
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_PIXF_FLAGS, (PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER));
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_PIXF_LAYERMASK, PFD_MAIN_PLANE);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_PIXF_PIXELTYPE, PFD_TYPE_RGBA);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_PIXF_ACCUMBITS, 0);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_PIXF_STENCILBITS, 0);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_WIDTH, BPLCC_SCREEN_X);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_HEIGHT, BPLCC_SCREEN_Y);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_DEPTH, 32);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_RESIZEDWINDOW, BPLCC_RESIZEWINDOW);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_EXITONESCAPE, BPLCC_EXIT_ON_ESCAPE);
	BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_SHOWCURSOR, BPLCC_SHOWMOUSECURSOR);
	BPLcc_WinData_SetPi(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_GL_FRUSTUMDATA, BPLcc_InitWindow_FrustumData, 6);

	//BPLcc_WinData_Set(&BPLcc_InitWinData_Obj, BPLCC_INITWINOBJ_SCR_FULLSCREEN, true);
}
